/*
 * Copyright (c) 2013-2020, APT Group, Department of Computer Science,
 * The University of Manchester.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

package uk.ac.manchester.tornado.unittests.tools.Exceptions;

/**
 * This exception should be thrown if the current system configuration is not suitable for running the test.
 *
 * Created by Dmitry Alexandrov
 */
public class UnsupportedConfigurationException extends RuntimeException {

    public UnsupportedConfigurationException(String message) {
        super(message);
    }

    public UnsupportedConfigurationException(String message, Throwable cause) {
        super(message, cause);
    }

    public UnsupportedConfigurationException(Throwable cause) {
        super(cause);
    }

    public UnsupportedConfigurationException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
        super(message, cause, enableSuppression, writableStackTrace);
    }
}
