## Selected Publications

* Michail Papadimitriou, Juan Fumero, Athanasios Stratikopoulos, Christos Kotselidis. [**Automatically Exploiting the
  Memory Hierarchy of GPUs through Just-in-Time
  Compilation**](https://www.research.manchester.ac.uk/portal/en/publications/automatically-exploiting-the-memory-hierarchy-of-gpus-through-justintime-compilation(8c2ba9c6-cef3-42c5-9f49-a87c97eaecd7).html)
  . Virtual Execution Environments (VEE) 2021.

* Michail Papadimitriou, Eleni Markou, Juan Funero, Athanasios Stratikopoulos, Florin Blanaru and Christos Kotselidis.
  [**Multiple-Tasks on Multiple-Devices (MTMD): Exploiting Concurrency in Heterogeneous Managed
  Runtimes**](https://www.research.manchester.ac.uk/portal/en/publications/multipletasks-on-multipledevices-mtmd-exploiting-concurrency-in-heterogeneous-managed-runtimes(16ca5803-718c-48c4-a6ef-48d0f1d1df6f).html)
  . Virtual Execution Environments (VEE) 2021.

* Michail Papadimitriou, Juan Fumero, Athanasios Stratikopoulos, Foivos S. Zakkak, Christos Kotselidis [**Transparent
  Compiler and Runtime Specializations for Accelerating Managed Languages on FPGAs**](https://arxiv.org/abs/2010.16304)
  in Programming 2021, _The Art, Science, and Engineering of Programming_
  . [Preprint](https://arxiv.org/pdf/2010.16304v1.pdf)

* Athanasios Stratikopoulos, Mihai-Cristian Olteanu, Ian Vaughan, Zoran Sevarac, Nikos Foutris, Juan Fumero, Christos
  Kotselidis. [**Transparent Acceleration of Java-based Deep Learning
  Engines.**](https://dl.acm.org/doi/abs/10.1145/3426182.3426188) _In International Conference on Managed Programming
  Languages & Runtimes (MPLR ’20)_
  . [Preprint](https://www.researchgate.net/publication/344401294_Transparent_Acceleration_of_Java-based_Deep_Learning_Engines)

* Juan Fumero, Michail Papadimitriou, Foivos Zakkak, Maria Xekalaki, James Clarkson, Christos Kotselidis. [**Dynamic
  Application Reconfiguration on Heterogeneous Hardware.**](https://dl.acm.org/citation.cfm?id=3313819) _In Proceedings
  of the 15th ACM SIGPLAN/SIGOPS International Conference on Virtual Execution Environments (VEE'19)
  ._ [Preprint](https://jjfumero.github.io/files/VEE2019_Fumero_Preprint.pdf)

* M. Papadimitriou, J. Fumero, A. Stratikopoulos and C. Kotselidis, [**Towards Prototyping and Acceleration of Java
  Programs onto Intel FPGAs**](https://ieeexplore.ieee.org/abstract/document/8735538). _IEEE 27th Annual International
  Symposium on Field-Programmable Custom Computing Machines (FCCM'19)_
  . [Preprint](https://www.researchgate.net/profile/Michalis_Papadimitriou/publication/332223416_Towards_Prototyping_and_Acceleration_of_Java_Programs_onto_Intel_FPGAs/links/5ca71d2f92851c64bd50d9e9/Towards-Prototyping-and-Acceleration-of-Java-Programs-onto-Intel-FPGAs.pdf)

* M. Xekalaki, J. Fumero and C. Kotselidis, [**Challenges and Proposals for Enabling Dynamic Heterogeneous Execution of
  Big Data Frameworks**](https://ieeexplore.ieee.org/abstract/document/8591039) _2018 IEEE International Conference on
  Cloud Computing Technology and Science (CloudCom)_. [DOI](10.1109/CloudCom2018.2018.00070).

* Juan Fumero, Christos Kotselidis. [**Using Compiler Snippets to Exploit Parallelism on Heterogeneous Hardware: A Java
  Reduction Case Study**](https://dl.acm.org/citation.cfm?id=3281292) In _Proceedings of the 10th ACM SIGPLAN
  International Workshop on Virtual Machines and Intermediate Languages (VMIL'18)_

* James Clarkson, Juan Fumero, Michalis Papadimitriou, Foivos S. Zakkak, Maria Xekalaki, Christos Kotselidis, Mikel
  Luján (The University of Manchester). **Exploiting High-Performance Heterogeneous Hardware for Java Programs using
  Graal**. *Proceedings of the 15th International Conference on Managed Languages & Runtime (
  ManLang'18)* [Preprint](https://www.researchgate.net/publication/327097904_Exploiting_High-Performance_Heterogeneous_Hardware_for_Java_Programs_using_Graal)
  , [DOI](https://dl.acm.org/doi/10.1145/3237009.3237016)

* Sajad Saeedi, Bruno Bodin, Harry Wagstaff, Andy Nisbet, Luigi Nardi, John Mawer, Nicolas Melot, Oscar Palomar,
  Emanuele Vespa, Tom Spink, Cosmin Gorgovan, Andrew Webb, James Clarkson, Erik Tomusk, Thomas Debrunner, Kuba Kaszyk,
  Pablo Gonzalez-de-Aledo, Andrey Rodchenko, Graham Riley, Christos Kotselidis, Björn Franke, Michael FP O'Boyle, Andrew
  J Davison, Paul HJ Kelly, Mikel Luján, Steve Furber. **Navigating the Landscape for Real-Time Localization and Mapping
  for Robotics and Virtual and Augmented Reality.** In Proceedings of the IEEE, 2018.

* C. Kotselidis, J. Clarkson, A. Rodchenko, A. Nisbet, J. Mawer, and M. Luján. [**Heterogeneous Managed Runtime Systems:
  A Computer Vision Case Study.**](https://dl.acm.org/citation.cfm?id=3050764) In Proceedings of the 13th ACM
  SIGPLAN/SIGOPS International Conference on Virtual Execution Environments (VEE '17)
  . [Link](https://dl.acm.org/citation.cfm?doid=3050748.3050764).

### Citation

If you are using **TornadoVM >= 0.2** (which includes the Dynamic Reconfiguration, the initial FPGA support and CPU/GPU
reductions), please use the following citation:

```bibtex
@inproceedings{Fumero:DARHH:VEE:2019,
 author = {Fumero, Juan and Papadimitriou, Michail and Zakkak, Foivos S. and Xekalaki, Maria and Clarkson, James and Kotselidis, Christos},
 title = {{Dynamic Application Reconfiguration on Heterogeneous Hardware.}},
 booktitle = {Proceedings of the 15th ACM SIGPLAN/SIGOPS International Conference on Virtual Execution Environments},
 series = {VEE '19},
 year = {2019},
 doi = {10.1145/3313808.3313819},
 publisher = {Association for Computing Machinery}
}
```

If you are using **Tornado 0.1** (Initial release), please use the following citation in your work.

```bibtex
@inproceedings{Clarkson:2018:EHH:3237009.3237016,
 author = {Clarkson, James and Fumero, Juan and Papadimitriou, Michail and Zakkak, Foivos S. and Xekalaki, Maria and Kotselidis, Christos and Luj\'{a}n, Mikel},
 title = {{Exploiting High-performance Heterogeneous Hardware for Java Programs Using Graal}},
 booktitle = {Proceedings of the 15th International Conference on Managed Languages \& Runtimes},
 series = {ManLang '18},
 year = {2018},
 isbn = {978-1-4503-6424-9},
 location = {Linz, Austria},
 pages = {4:1--4:13},
 articleno = {4},
 numpages = {13},
 url = {http://doi.acm.org/10.1145/3237009.3237016},
 doi = {10.1145/3237009.3237016},
 acmid = {3237016},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Java, graal, heterogeneous hardware, openCL, virtual machine},
}

```
