# Additional Resources

## Videos

- A. Stratikopoulos, [TornadoVM: A virtual machine for exploiting high performance heterogeneous hardware of Java programs](https://mirrors.dotsrc.org/fosdem/2020/H.1302/tornadovm.mp4), FOSDEM, 01/02/2020.

- J. Fumero, [TornadoVM: A virtual machine for exploiting high performance heterogeneous hardware](https://www.youtube.com/watch?v=6oRmxjoe03g), Joker<?> Conference, 26/10/2019.

- J. Fumero, [Overview of TornadoVM](https://www.youtube.com/watch?v=nPlacnadR6k), JVMLS, 31/07/2019.


## Presentations

* TornadoVM Slides @ QConLondon 2020: [link](https://github.com/jjfumero/jjfumero.github.io/blob/master/files/QCON2020-TornadoVM.pdf)
* TornadoVM Slides @ JokerConf<?> 2019: [link](https://github.com/jjfumero/jjfumero.github.io/blob/master/files/JVMLS2019-TornadoVM.pdf)
* TornadoVM Slides @ JVMLS 2019: [link](https://github.com/jjfumero/jjfumero.github.io/blob/master/files/JVMLS2019-TornadoVM.pdf)


## Articles

- Article by Juan Fumero, [TornadoVM: Accelerating Java with GPUs and FPGAs](https://www.infoq.com/articles/tornadovm-java-gpu-fpga/), InfoQ, 13/06/2020.

- Article by C. Swan, [TornadoVM: Running Java on GPUs and FPGAs](https://www.infoq.com/news/2020/03/TornadoVM-QCon-London/), InfoQ, 08/03/2020.

- F. Blanaru, J. Fumero, C.Kotselidis, [Towards a unified VM for hardware acceleration of managed languages](https://e2data.eu/blog/towards-a-unified-vm-for-hardware-acceleration-of-managed-languages), E2DATA, 20/02/2020.

- J. Fumero, A. Stratikopoulos, C.Kotselidis, [TornadoVM: Running your Java programs on heterogeneous hardware](https://jaxenter.com/tornado-vm-java-162460.html), JAXEnter, 17/10/2019.

- C. Kotselidis, [TornadoVM: Dynamic Reconfiguration on Heterogeneous Hardware](https://e2data.eu/blog/tornadovm-dynamic-reconfiguration-on-heterogeneous-hardware), E2Data, 28/02/2019.



## Demos & Artefacts

* Examples used for QConLondon: [link](https://github.com/jjfumero/qconlondon2020-tornadovm)

* TornadoVM running with KFusion Microsoft Kinet: [link](https://github.com/jjfumero/jjfumero.github.io/blob/master/files/videos/KFUSION-TORNADOVM-0.3.webm)

* TornadoVM running with Docker images on NVIDIA GPUs: [link](https://github.com/jjfumero/jjfumero.github.io/blob/master/files/videos/TornadoDockerGPU.webm)
